$APPTYPE CONSOLE: $TYPECHECK ON
$include "sqldata1.inc"

DIM dsn as SQLDATA1
DEFSTR DB$,User$,Pwd$,DS$,Query$
DEFINT i,j,ncols
app.title="HotBasic(tm) SQLDATA Object Access Tool"
app.icon="hotbasic.ico"

'make list of on-line data sources
Next_DB:
DB$=LEFT$(dsn.DataSource,24)
DB$=DB$+SPACE$(24-DB$.length)+dsn.Driver
IF DS$.IndexOf(DB$)<0 THEN DS$.AddItems DB$: Goto Next_DB
IF DS$.Length=0 THEN PRINT "No on-line databases": Goto pause_end

data_open:
PRINT "Data Source             Driver"
PRINT DS$

INPUT "Data Source to open: "; DB$
IF DB$=null THEN Goto pause_end
User$.clear: Pwd$.clear
INPUT "User ID, if any:  "; User$
IF User$=null THEN Goto dsn_connect
INPUT "Password, if any: ";Pwd$

dsn_connect:
dsn.Connect(DB$,User$,Pwd$)
PRINT ".EnvHandle   = "; HEX$(dsn.EnvHandle)
PRINT ".DBHandle    = "; HEX$(dsn.DBHandle)
Gosub DB_error
IF dsn.Error THEN Goto data_open
PRINT

PRINT "Command example: select *;"

next_cmd:
PRINT "SQL Command: ";: Query$=input$  'don't parse commas in query
IF Query$=null THEN Goto dsn_close

dsn.Command(Query$)

IF dsn.Error THEN
  PRINT "Bad Query": gosub DB_error
ELSE
  ncols = dsn.FieldCount
  Print "No. Columns = "; Str$(ncols)
  FOR j=1 TO ncols
  PRINT dsn.Field(j,1); tab;
  NEXT j: PRINT
  WHILE dsn.Row<>100
  FOR j=1 TO ncols
  PRINT dsn.RowValue(j,1); tab;
  NEXT j: PRINT
  END WHILE
  dsn.FreeMemory
END IF
Goto next_cmd

dsn_close:
PRINT "Closing Data Source Connection"
dsn.Close: PRINT: Goto data_open

pause_end:
PAUSE
END

DB_error:
PRINT ".Error       = "; hex$(dsn.Error)
dsn.DiagRec
PRINT ".DiagRec:"
print dsn.ErrMsg
PRINT ".SQLState    = "; dsn.SQLState
PRINT ".NativeError = "; dsn.NativeError
PRINT ".DiagRecRet  = "; dsn.DiagRecRet
return
